"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var nodes_1 = require("../nodes");
/**
 * Renders a DocNode tree as plain text, without any rich text formatting or markup.
 */
var PlainTextEmitter = /** @class */ (function () {
    function PlainTextEmitter() {
    }
    PlainTextEmitter.hasAnyTextContent = function (nodeOrNodes) {
        if (nodeOrNodes instanceof nodes_1.DocNode) {
            nodeOrNodes = [nodeOrNodes];
        }
        for (var _i = 0, nodeOrNodes_1 = nodeOrNodes; _i < nodeOrNodes_1.length; _i++) {
            var node = nodeOrNodes_1[_i];
            switch (node.kind) {
                case "FencedCode" /* FencedCode */:
                case "CodeSpan" /* CodeSpan */:
                case "EscapedText" /* EscapedText */:
                case "LinkTag" /* LinkTag */:
                    return true;
                case "PlainText" /* PlainText */:
                    var docPlainText = node;
                    // Is there at least one non-spacing character?
                    if (docPlainText.text.trim().length > 0) {
                        return true;
                    }
                    break;
            }
            for (var _a = 0, _b = node.getChildNodes(); _a < _b.length; _a++) {
                var childNode = _b[_a];
                if (this.hasAnyTextContent(childNode)) {
                    return true;
                }
            }
        }
        return false;
    };
    return PlainTextEmitter;
}());
exports.PlainTextEmitter = PlainTextEmitter;
//# sourceMappingURL=PlainTextEmitter.js.map